﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace erettsegi16_Szojatek
{
    class Szó
    {
        public Szó(string s){szó = s;}
        public string szó {get; set;}
        public int magánh 
        { 
            get 
            {
                int db = 0;
                foreach (char c in szó) if ("aeiou".Contains(c)) db++;
                return db;
            } 
        }
        public int egyéb { get{return szó.Length-magánh;}}
        public string középső3 { get {return szó.Substring(1, 3);} }
    }


    class Szójáték
    {
        static void Main()
        {
            //1. Feladat:
            Console.Write("1. Feladat: Kérek egy szót:");
            Console.WriteLine(new Szó(Console.ReadLine()).magánh>0 ? "Van benne magánhangzó" : "Nincs benne magángangzó");

            //2. feladat
            string leghosszabb="";
            using (StreamReader sr = new StreamReader("szoveg.txt"))
                while (!sr.EndOfStream)
                {
                    string szó=sr.ReadLine();
                    if (szó.Length > leghosszabb.Length) leghosszabb = szó; 
                }
            Console.WriteLine("\n2. Feladat: A leghosszabb szó: {0} hossza: {1} karakter", leghosszabb, leghosszabb.Length);
            
            //3. feladat
            Console.WriteLine("\n3. feladat:");
            string[] szoveg_txt = File.ReadAllLines("szoveg.txt");
            List<Szó> szavak = new List<Szó>();
            foreach (var i in szoveg_txt) szavak.Add(new Szó(i));
            var kivételek = szavak.Where(x => x.magánh > x.egyéb);
            foreach (var i in kivételek) Console.Write("{0} ", i.szó);
            Console.WriteLine("\nStatisztika: {0} / {1} : {2:P}",kivételek.Count(), szavak.Count(),(double)kivételek.Count()/szavak.Count());

            //4.feladat
            var ötk = szavak.Where(x=>x.szó.Length==5);
            Console.Write("\n4. Feladat: Kérek egy 3 karakter hosszú szót:");
            string belső3=Console.ReadLine();
            foreach (var i in ötk.Where(x => x.középső3 == belső3)) Console.Write("{0} ", i.szó);

            //5. feladat
            Console.Write("\n5. Feladat: letra.txt");
            var letra_txt = ötk.GroupBy(x => x.középső3).Where(x=>x.Count()>1);
            using (StreamWriter sw = new StreamWriter("letra.txt"))
                foreach (var i in letra_txt)
                {
                    foreach (var j in i) sw.WriteLine(j.szó);
                    sw.WriteLine();
                }

            Console.ReadKey();
        }
    }
}
